	for(k=0; k<cur_numcols; k++){
		if (vcg_var_degree[k] == 0){
			tmp_double_cur_numcols[k] = obj_fun_coef[k];
		} else {
			tmp_double_cur_numcols[k] = obj_fun_coef[k] / sqrt(vcg_var_degree[k]);
		}
	}
	price_per_sqrt_number_stddev = sqrt(d_var(tmp_double_cur_numcols, cur_numcols));

	/* Output: price-based features */
	if (debug) fprintf(stderr, "Output: prices_stddev, price_per_number_stddev, price_per_sqrt_number_stddev\n");
	printf(", %lf, %lf, %lf", prices_stddev, price_per_number_stddev, price_per_sqrt_number_stddev);


	/* Compute new features */
	}

	
	
	

	
	sw2.Start();
	fprintf(stderr, "Enumerating nonzero entries to compute VCG features and A_ij features: will take Big Theta(# nonzero entries) time...\n");

	
	
	
	for (var_set_num = 0; var_set_num<3; var_set_num++){
		/* Allocate memory for degree counters and lots of other arrays. */
		vcg_constraint_degree = new int[cur_numrows];
		rhs_b = new double[cur_numrows];
		a_normalized_varcoefs = new double[cur_numrows];

		vcg_var_degree = new int[cur_numcols];
		vg_degree = new int[cur_numcols];
		vg_degree_copy = new int[cur_numcols];
		vg_neighbours = new int*[cur_numcols];

		all_clust_coef = new double[cur_numcols];
		obj_fun_coef = new double[cur_numcols];
		tmp_double_cur_numcols = new double[cur_numcols];
		up_bound = new double[cur_numcols];
		low_bound = new double[cur_numcols];

		/* Initialize degree counters. */
		for (i=0; i<cur_numrows; i++) vcg_constraint_degree[i] = 0;
		for (k=0; k<cur_numcols; k++) vcg_var_degree[k] = 0;
		for (k=0; k<cur_numcols; k++) vg_degree[k] = 0;

		/* Get right hand side, the b array */
		status = CPXgetrhs (env, lp, rhs_b, 0, cur_numrows-1);
		fprintf(stderr, "#vars=%d, #constraints=%d, #nonzeros=%d\n", cur_numcols, cur_numrows, nzcnt);

		if ( status ) {
			fprintf (stderr, "Failed to get right hand side, the b array. Error %d\n", status);
			goto TERMINATE;
		}

		//printMatrixInt(vg_degree, 1, cur_numcols);
		vset = vector< set<int> > (cur_numcols);


		/* Enumerate nonzero entries, get variable and constraint degrees, and compute features of A matrix */
		count = 0;
		for(i=0; i<cur_numrows; i++){
			if (i==cur_numrows-1) {
				for_up_bound = nzcnt_returned; 	/* last row, special case for the upper limit of the loop */
			} else {
				for_up_bound = rmatbeg[i+1];
			}
			sum_abs = 0;
			for (j=rmatbeg[i]; j<for_up_bound; j++){
				k = rmatind[j];
				vcg_constraint_degree[i]++;
				vcg_var_degree[k]++;

				/* For computing features of the rows of the A matrix */
				a_ik = rmatval[j];
				tmp_double_cur_numcols[j-rmatbeg[i]] = fabs(a_ik); // absolute of nonzero entries in this row.
				sum_abs += fabs(a_ik);

				if (rhs_b[i] > 1e-6 || rhs_b[i] < -1e-6){
					/* A_ij_normalized holds constraint coefficients of normalized MIP with b = vector of ones (ignoring those rows with b=0 */
					A_ij_normalized[count++] = a_ik / rhs_b[i];
				}

				//printf(" row=%d, j=%d, k=%d, a_ik=%lf, rhs=%lf, begin=%d, end=%d,#vars in constraint=%d\n", i, j, k, a_ik, rhs_b[i], rmatbeg[i], for_up_bound , (for_up_bound - rmatbeg[i] - 1));
			}

			/* Compute variation coefficient of normalized absolute nonzero entries in this row */
			num_nz_this_row = for_up_bound-rmatbeg[i];
			for (j=0; j<num_nz_this_row; j++){
				tmp_double_cur_numcols[j] /= sum_abs;
			}
			if (num_nz_this_row == 0 ){
				a_normalized_varcoefs[i] = 0;
			} else {
				a_normalized_varcoefs[i] = sqrt(d_var(tmp_double_cur_numcols, num_nz_this_row)) / d_mean(tmp_double_cur_numcols, num_nz_this_row); 
			}
			//printf("num_nz_this_row=%d:\n",num_nz_this_row);
			//printMatrixDouble(tmp_double_cur_numcols, 1, num_nz_this_row);
			
			//printf("rmatbeg:\n");
			//printMatrixInt(rmatbeg, 1, cur_numrows);
			
		}

		//printMatrixDouble(a_normalized_varcoefs, 1, cur_numrows);
		a_ij_varcoef_avg = d_mean(a_normalized_varcoefs, cur_numrows);
		a_ij_varcoef_std = sqrt(d_var(a_normalized_varcoefs, cur_numrows));

		a_ij_magnitude_mean = d_mean(A_ij_normalized, count);
		a_ij_magnitude_std = sqrt(d_var(A_ij_normalized, count));


		/* Bipartite variable-constraint graph (VCG); 4 features about degree of variables, 4 about constraints */
		
		/* 1. Degree of variable nodes */
		vcg_var_deg_mean = i_mean(vcg_var_degree, cur_numcols);
		vcg_var_deg_std = sqrt(i_var(vcg_var_degree, cur_numcols));
		vcg_var_deg_min = cur_numrows+1;
		vcg_var_deg_max = -1;
		for(i=0; i<cur_numcols; i++){ 
			if( vcg_var_degree[i] < vcg_var_deg_min ) vcg_var_deg_min = vcg_var_degree[i];
			if( vcg_var_degree[i] > vcg_var_deg_max ) vcg_var_deg_max = vcg_var_degree[i];
			if (vcg_var_degree[i] == 0){
				fprintf(stderr, "Warning: variable %d is not mentioned in any linear constraints ... \n", i);
			}
		}

		/* Variable-constraint graph features, degree of variable nodes */
		/* FH: different from the original WDP feature code, I don't normalize these by NrowConstraints -- for std, this normalization was also omitted (forgotten?) in the original code. */
		if (debug) fprintf(stderr, "Output: vcg_var_deg_mean, vcg_var_deg_std, vcg_var_deg_min, vcg_var_deg_max\n");
		printf(", %lf, %lf, %d, %d", vcg_var_deg_mean, vcg_var_deg_std, vcg_var_deg_min, vcg_var_deg_max);

		/* 2. Degree of constraint nodes */
		vcg_con_deg_mean = i_mean(vcg_constraint_degree, cur_numrows);
		vcg_con_deg_std = sqrt(i_var(vcg_constraint_degree, cur_numrows));
		vcg_con_deg_min = cur_numcols+1;
		vcg_con_deg_max = -1;
		for(j=0; j<cur_numrows; j++){ 
			if( vcg_constraint_degree[j] < vcg_con_deg_min ) vcg_con_deg_min = vcg_constraint_degree[j];
			if( vcg_constraint_degree[j] > vcg_con_deg_max ) vcg_con_deg_max = vcg_constraint_degree[j];
			if (vcg_constraint_degree[j] == 0){
				fprintf(stderr, "Warning: constraint %d does not include any variables ... \n", j);
			}
		}

		/* Variable-constraint graph features, degree of constraint nodes */
		/* FH: different from the original WDP feature code, I don't normalize these by McolumnVars. */
		/* Output: bipartite variable-constraint graph features; 4 features about degree of variables, 4 about constraints */
		if (debug) fprintf(stderr, "Output: vcg_con_deg_mean, vcg_con_deg_std, vcg_con_deg_min, vcg_con_deg_max\n");
		printf(", %lf, %lf, %d, %d", vcg_con_deg_mean, vcg_con_deg_std, vcg_con_deg_min, vcg_con_deg_max);



	
	
	
	/* Output: new features: percentage continuous variables, support size for discrete variables (mean, stddev), A matrix (4 feats) */
	if (debug) fprintf(stderr, "Output: ratio_cont_var, support_size_mean, support_size_std, a_ij_magnitude_mean, a_ij_magnitude_std, a_ij_varcoef_avg, a_ij_varcoef_std, ratio_unbounded_discrete\n");
	printf(", %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf", ratio_cont_var, support_size_mean, support_size_std, a_ij_magnitude_mean, a_ij_magnitude_std, a_ij_varcoef_avg, a_ij_varcoef_std, ratio_unbounded_discrete);

	time_nonzero_enum = sw2.Lap();
	if (debug) fprintf(stderr, " enumeration of nonzero elements took %lfs\n", time_nonzero_enum);

	if (compute_vg){
		sw2.Start();
		fprintf(stderr, "Computing VG features - O(#num constraints * (#num vars in constraint)^2) ...\n");
		for(i=0; i<cur_numrows; i++){
			if (i==cur_numrows-1) {
				for_up_bound = nzcnt_returned-1; 	/* last row, special case for the upper limit of the loop */
			} else {
				for_up_bound = rmatbeg[i+1];
			}
			sum_abs = 0;
			for (j=rmatbeg[i]; j<for_up_bound; j++){
				k = rmatind[j];
				/* Collect neighbours */
				for (j2=j+1; j2<for_up_bound; j2++){
					k2 = rmatind[j2];
					vset[ k ].insert( k2 );
					vset[ k2 ].insert( k );
				}
			}
		}

		for(k=0; k<cur_numcols; k++){
			vg_degree[k] = vset[ k ].size();
			vg_neighbours[k] = new int[vg_degree[k]];
			count = 0;
			for (it=vset[ k ].begin(); it!=vset[ k ].end(); it++){
				vg_neighbours[k][count++] = *it;
			}
		}
		// printMatrixInt(vg_degree, 1, cur_numcols);

		vg_deg_min = cur_numrows+1;
		vg_deg_max = -1;
		n_edges = 0;
		for(k=0; k<cur_numcols; k++){
			if( vg_degree[k] < vg_deg_min ){
				vg_deg_min = vg_degree[k];
			}
			if( vg_degree[k] > vg_deg_max ){
				vg_deg_max = vg_degree[k];
			}
			n_edges += vg_degree[k];
		}
		n_edges /= 2;
		edge_density = n_edges / (double)( (cur_numcols*(cur_numcols-1)) / 2 );
	//	printf("n_edges=%d, full=%lf\n", n_edges, (double)( (cur_numcols*(cur_numcols-1)) / 2 ));
	//	vg_deg_mean = i_mean(vg_degree, cur_numcols);
		vg_deg_std = sqrt(i_var(vg_degree, cur_numcols));

		for (k=0; k<cur_numcols; k++){
			vg_degree_copy[k] = vg_degree[k];
		}

		/* Sorting vg_degree_copy, so it's not matching with the columns anymore! */
		quick_sort(vg_degree_copy, cur_numcols); 
		vg_deg_q0_25 = vg_degree_copy [cur_numcols / 4];
		vg_deg_med = vg_degree_copy [2*cur_numcols / 4];
		vg_deg_q0_75 = vg_degree_copy [3*cur_numcols / 4];

		/* Output: variable graph (VG) features: edge density, degree statistics */
		if (debug) fprintf(stderr, "Output: edge_density, vg_deg_std, vg_deg_max, vg_deg_min, vg_deg_q0_25, vg_deg_med, vg_deg_q0_75\n");
		printf(", %lf, %lf, %d, %d, %lf, %lf, %lf", edge_density, vg_deg_std, vg_deg_max, vg_deg_min, vg_deg_q0_25, vg_deg_med, vg_deg_q0_75);

		time_vg = sw2.Lap();
		if (debug) fprintf(stderr, " VG features took %lfs\n", time_vg);

		if (compute_clust_coef){
			sw2.Start();
			fprintf(stderr, "Computing clustering coefficient - O(#variables^3) ...\n");
			/* Compute clustering coefficient and deviation */
			for (k=0; k<cur_numcols; k++){
				num_neighbour_edges = 0;
				if( vg_degree[k] <= 1 ){
					all_clust_coef[k] = 0;
				} else {
					for (i=0; i<vg_degree[k]; i++){
						/* For each variable k and each of its neighbours k2': intersect N(k) and N(k2') (which are already sorted), divide by 2 */
						k2 = vg_neighbours[k][i];
						num_neighbour_edges += size_of_intersection(vg_neighbours[k], vg_neighbours[k2], vg_degree[k], vg_degree[k2]);
					}
					num_neighbour_edges /= 2;
					all_clust_coef[k] = num_neighbour_edges/double(vg_degree[k]*(vg_degree[k]-1)/2);
				}
			}
		//	printMatrixDouble(all_clust_coef, 1, cur_numcols);

			clust_coef = d_mean(all_clust_coef, cur_numcols);
			deviation = sqrt(d_var(all_clust_coef, cur_numcols));

			/* Output: more variable graph (VG) features: clustering coefficient and deviation*/
			if (debug) fprintf(stderr, "Output: clust_coef, deviation\n");
			printf(", %lf, %lf", clust_coef, deviation);

			time_clust_coef = sw2.Lap();
			if (debug) fprintf(stderr, " clustering coefficient took %lfs\n", time_clust_coef);
		}
	}

	if (compute_relax){
		sw2.Start();
		/* Rest of the file: LP features. */
		if (probtype == CPXPROB_LP || probtype == CPXPROB_QP || probtype == CPXPROB_QCP){
			/* These problem types have only continuous variables, so zero LP slack; using lp_objval=0 here */
			lp_avg = 0;
			lp_l2_avg = 0;
			lp_linf = 0;
			lp_objval = 0;
		} else {
			var_indices_to_make_cont = new int[cur_numcols];
			num_var_indices_to_make_cont = 0;

			for(i=0; i<cur_numcols; i++){
				//printf("xctype[i] = %c, low_bound[i]=%lf\n", xctype[i], low_bound[i]);
				if (xctype[i] != 'C' && xctype[i] != 'S'){ // if not (continuous or semi-continuous)
					if (xctype[i] == 'B'){
						indices[0] = i;
						/* For previously binary variables, set bounds to [0,1] */
						status = CPXchgbds (env, lp, 1, indices, Lchar, lu);
						status = CPXchgbds (env, lp, 1, indices, Uchar, up);
						low_bound[i] = lu[0];
						up_bound[i] = up[0];
					}
					var_indices_to_make_cont[num_var_indices_to_make_cont++] = i;

					/* Set lower bound eps lower, upper bound eps higher to avoid numerical problems. */
					indices[0] = i;
					lu_eps[0] = low_bound[i]; //-CPX_INFBOUND; //
					up_eps[0] = up_bound[i]; //CPX_INFBOUND;//
					status = CPXchgbds (env, lp, 1, indices, Lchar, lu_eps);
					status = CPXchgbds (env, lp, 1, indices, Uchar, up_eps);
				}
			}


			/* Relax problem: change all variables to continuous, then solve as LP (or QP/QCP) */

			/* Set LP strategy, optimize the LP and obtain solution. */
			if (probtype == CPXPROB_MILP || probtype == CPXPROB_FIXEDMILP){
				status = CPXchgprobtype (env, lp, CPXPROB_LP);
				status = CPXsetintparam (env, CPX_PARAM_LPMETHOD, CPX_ALG_AUTOMATIC);
				if ( status ) {
					fprintf (stderr, 
							"Failed to set LP optimization method, error %d.\n", status);
					goto TERMINATE;
				}
				status = CPXlpopt (env, lp);
				if ( status ) {
					fprintf (stderr, "Failed to optimize LP.\n");
					goto TERMINATE;
				}

			} else if (probtype == CPXPROB_MIQP || probtype == CPXPROB_FIXEDMIQP){
				status = CPXchgprobtype (env, lp, CPXPROB_QP);
				status = CPXsetintparam (env, CPX_PARAM_QPMETHOD, CPX_ALG_AUTOMATIC);
				if ( status ) {
					fprintf (stderr, 
							"Failed to set QP optimization method, error %d.\n", status);
					goto TERMINATE;
				}
				status = CPXqpopt (env, lp);
				if ( status ) {
					fprintf (stderr, "Failed to optimize QP.\n");
					goto TERMINATE;
				}

			} else {
				status = CPXchgprobtype (env, lp, CPXPROB_QCP);
				status = CPXsetintparam (env, CPX_PARAM_LPMETHOD, CPX_ALG_AUTOMATIC);
				if ( status ) {
					fprintf (stderr, 
							"Failed to set QCP optimization method, error %d.\n", status);
					goto TERMINATE;
				}
				status = CPXbaropt (env, lp);
				if ( status ) {
					fprintf (stderr, "Failed to optimize QCP.\n");
					goto TERMINATE;
				}

			}

		    solnstat = CPXgetstat (env, lp);
			if      ( solnstat == CPX_STAT_UNBOUNDED ) {
				fprintf (stderr, "Relaxed model is unbounded\n");
				goto TERMINATE;
			}
			else if ( solnstat == CPX_STAT_INFEASIBLE ) {
				fprintf (stderr, "Relaxed model could not be shown to be feasible\n");
				goto TERMINATE;
			}
			else if ( solnstat == CPX_STAT_INForUNBD ) {
				printf ("Relaxed model is infeasible or unbounded\n");
				goto TERMINATE;
			} 
			else {
				status = CPXsolninfo (env, lp, &solnmethod, &solntype, NULL, NULL);
				if ( status ) {
					fprintf (stderr, "Failed to obtain LP solution info.\n");
					goto TERMINATE;
				}
				//printf ("Solution status %d, solution method %d\n", solnstat, solnmethod);
			}

			if ( solntype == CPX_NO_SOLN ) {
				fprintf (stderr, "Relaxed solution not available.\n");
				//goto TERMINATE;
			}
			    
			status = CPXgetobjval (env, lp, &lp_objval);
			if ( status ) {
				fprintf (stderr, "Failed to obtain relaxed objective value.\n"); 
				// FH: if this error occurs for an instance, one could code "failed objective" with a special value
				goto TERMINATE;
			}
			//printf ("Objective value %lf\n", lp_objval);

			/* Retrieve solution vector */
			x = (double *) malloc (cur_numcols*sizeof(double));
			if ( x == NULL ) {
				fprintf (stderr, "No memory for solution.\n");
				goto TERMINATE;
			}

			status = CPXgetx (env, lp, x, 0, cur_numcols-1);
			if ( status ) {
				fprintf (stderr, "Failed to obtain primal solution.\n");
				goto TERMINATE;
			}

			for(j=0; j<num_var_indices_to_make_cont; j++) {
				i = var_indices_to_make_cont[j];
				double dist = min(fabs(x[i]), fabs(x[i] - 1));
				sum += dist;
				l2 += dist*dist;
				max_dist = max(max_dist, dist);
			}

			lp_avg = sum / double(num_var_indices_to_make_cont);
			lp_l2_avg = sqrt(l2/double(num_var_indices_to_make_cont));
			lp_linf = max_dist;
		}
		/* Output: LP features */
		if (debug) fprintf(stderr, "Output: lp_avg, lp_l2_avg, lp_linf, lp_objval\n");
		printf(", %lf, %lf, %lf, %lf\n", lp_avg, lp_l2_avg, lp_linf, lp_objval);

		time_relax = sw2.Lap();
		if (debug) fprintf(stderr, " Solving relaxed problem took %lfs\n", time_relax);
	}

   /* Free up the basis and solution */

   free_and_null ((char **) &cstat);
   free_and_null ((char **) &rstat);
   free_and_null ((char **) &x);

   /* Free up the problem, if necessary */

   if ( lp != NULL ) {
      status = CPXfreeprob (env, &lp);
      if ( status ) {
         fprintf (stderr, "CPXfreeprob failed, error code %d.\n", status);
      }
   }

   /* Free up the CPLEX environment, if necessary */

   if ( env != NULL ) {
      status = CPXcloseCPLEX (&env);

      /* Note that CPXcloseCPLEX produces no output,
         so the only way to see the cause of the error is to use
         CPXgeterrorstring.  For other CPLEX routines, the errors will
         be seen if the CPX_PARAM_SCRIND indicator is set to CPX_ON. */

      if ( status ) {
         char  errmsg[1024];
         fprintf (stderr, "Could not close CPLEX environment.\n");
         CPXgeterrorstring (env, status, errmsg);
         fprintf (stderr, "%s", errmsg);
      }
   }

	time_total = sw.Lap();
	printf("time_parse, time_enum_nz, time_vg, time_clust_coef, time_relax, time_total\n");
	printf("%lf, %lf, %lf, %lf, %lf, %lf\n", time_parse, time_nonzero_enum, time_vg, time_clust_coef, time_relax, time_total);
	printf("Total feature computation time: %lfs", time_total);

TERMINATE:
	printf("\n");
   return (status);

}  /* END main */




/* This simple routine frees up the pointer *ptr, and sets *ptr to NULL */

static void
free_and_null (char **ptr)
{
   if ( *ptr != NULL ) {
      free (*ptr);
      *ptr = NULL;
   }
} /* END free_and_null */


static void
usage (char *progname)
{
   fprintf (stderr,"Usage: %s filename\n", progname);
   fprintf (stderr,"   where filename is a MIP instance file in .MPS, .LP, or .SAV format.\n");
   fprintf (stderr," Exiting...\n");
} /* END usage */













	
	feature_names[num_features] = 'n_constraints'; features[num_features++] = cur_numrows;
	feature_names[num_features] = 'nzcnt'; features[num_features++] = nzcnt;
	feature_names[num_features] = 'ratio_nz'; features[num_features++] = (nzcnt+0.0)/(cur_numcols*cur_numrows);

	
	/* Compute features for quadratically-constrained problems */
	num_q_constr = CPXgetnumqconstrs (env, lp);
	num_quad = CPXgetnumquad (env, lp); /* number of variables that have quadratic objective coefficients */
	num_qpnz = CPXgetnumqpnz (env, lp);
	
	/* Output: QP features */
	feature_names[num_features] = 'num_q_constr'; features[num_features++] = num_q_constr;
	feature_names[num_features] = 'num_quad'; features[num_features++] = num_quad;
	feature_names[num_features] = 'num_qpnz'; features[num_features++] = num_qpnz;
	
	


	/* Output: bipartite variable-constraint graph features; 4 features about degree of variables, 4 about constraints */
	printf(", vcg_var_deg_mean, vcg_var_deg_std, vcg_var_deg_min, vcg_var_deg_max, vcg_con_deg_mean, vcg_con_deg_std, vcg_con_deg_min, vcg_con_deg_max");

	/* Output: price-based features */
	printf(", prices_stddev, price_per_number_stddev, price_per_sqrt_number_stddev");

	/* Output: new features: percentage continuous variables, support size for discrete variables (mean, stddev), A matrix (4 feats) */
	printf(", ratio_cont_var, support_size_mean, support_size_std, a_ij_magnitude_mean, a_ij_magnitude_std, a_ij_varcoef_avg, a_ij_varcoef_std, ratio_unbounded_discrete");

	if (compute_vg){
		/* Output: variable graph (VG) features: edge density, degree statistics*/
		printf(", edge_density, vg_deg_std, vg_deg_max, vg_deg_min, vg_deg_q0_25, vg_deg_med, vg_deg_q0_75");

		if (compute_clust_coef){
			/* Output: more variable graph (VG) features: clustering coefficient and deviation*/
			printf(", clust_coef, deviation");
		}
	}

	if( compute_relax ){
		/* Output: LP features */
	    printf(", lp_avg, lp_l2_avg, lp_linf, lp_objval\n");
	}